(function() {
    "use strict";

    //----edit in your environment begin----------------//
    var WIDGET_MODE = 2;//2:widget within kinton window;1:widget in normal window
    var KINTON_URL = 'https://2yxxxxxx.cybozu.com';//利用環境に合わせてURL変更
    var APPKEY = '1';
    var CIMURL = 'https://test.brekeke.jp/cim/';//利用環境に合わせてURL変更

    //アプリのField情報(必須設定)
    var TEL_FIELD_CODE = "TEL";//電話番号
    var CUSTOMER_FIELD_CODE = "CustomerName";//カスタマー名前
    	
    var ACTIVITY_DATE_FIELD_CODE="日付";//履歴の通話日時(日時型)
    //var ACTIVITY_TYPE_FIELD_CODE="actionType";//履歴の種別(ドロップダウン型、電話/チャット)
    var ACTIVITY_CALL_TYPE_FIELD_CODE="callType";//履歴の通話種別(ドロップダウン型、発信/着信)
    var ACTIVITY_RFS_FIELD_CODE="rfsInfo";//履歴のRFS情報(文字列1行型,tenant + agentid + callid)

    //履歴のその他field（ない場合、null設定)
    var ACTIVITY_OTHER_FIELDS_INFO={
        "文字列__1行__2":{"type": "SINGLE_LINE_TEXT", "value": ""},//メモー
        "添付ファイル":{"type":"FILE","value":[]},
    //"文字列__1行__3":{"type":"SINGLE_LINE_TEXT","value":""}
    }

    //履歴のRFSのFieldのclass情報(ブラウザ側のdevTools確認)
    var ACTIVITY_RFS_FIELD_CLASS = '.control-value-gaia.value-5519821';//


    //----edit in your environment end----------------//


    var CONTENT_H = 197;

    var showWidget = function()  {
        if(WIDGET_MODE == 1){
            return;
        }
        var buttonText = 'Widget';
        if ($('.kintoneSI-widget').length !== 0) return;

        var height = localStorage.getItem('kintoneSI-height');
        if(height){
            CONTENT_H = parseInt(height);
        }

        var $div = $('<div class="kintoneSI-widget"></div>');

        $div.append('<div class="kintoneSI-widget-header" value="false" id="widgetContentsOnline_Footer">\n' +
            '        <table id="widgetContentsOnline_Footer_Body">\n' +
            '            <tbody>\n' +
            '            <tr>\n' +
            '                <td id="widgetContentsOnline_Footer_Body_Logo" >logo</td>\n' +
            '                <td id="widgetContentsOnline_Footer_Body_Title" title="Brekeke Customer Interaction Manager">CIM</td>\n' +
            '                <td id="widgetContentsOnline_Footer_Body_Direction"><span class="toggle-icon">▲</span></td>\n' +
            '            </tr>\n' +
            '            </tbody>\n' +
            '        </table>\n' +
            '    </div>');
        var toolbarIFrame = $('<iframe src="" frameborder="0" width="100%" height="100%" scrolling="auto" marginheight="0" marginwidth="0" allowfullscreen mozallowfullscreen webkitallowfullscreen></iframe>');
        var toolbarContainer = $('<div class="kintoneSI-widget-body" style="height:' + CONTENT_H + 'px;"></div>');
        toolbarContainer.append(toolbarIFrame);
        $div.append(toolbarContainer);
        $(document.body).append($div);


        toolbarIFrame[0].src= CIMURL + 'apps/cybozu/';

        // //display
        if (localStorage.getItem('kintoneSI-toggle') === 'true') {
            $('.kintoneSI-widget').css({'bottom': '0px'});
            $('.kintoneSI-widget').find('.toggle-icon').text('▼');
            $('.kintoneSI-widget-header').attr('value', 'true');
        }

        $('.kintoneSI-widget-header').on('click', function() {
            if ($(this).attr('value') === 'false') {
                //display
                $(this).parent().animate({'bottom': '0px'});
                $(this).find('.toggle-icon').text('▼');
                $(this).attr('value', 'true');
                localStorage.setItem('kintoneSI-toggle', 'true');
            } else {
                //no display
                var modify_h = parseInt(CONTENT_H) + 2;
                $(this).parent().animate({'bottom': '-' + modify_h + 'px'});
                $(this).find('.toggle-icon').text('▲');
                $(this).attr('value', 'false');
                localStorage.setItem('kintoneSI-toggle', 'false');
            }
        });
        var logo_html = '<img src="' + CIMURL + 'apps/cybozu/lib/skin/sf/img/brekeke_logo.png"/>'
        var logo_elm = document.getElementById('widgetContentsOnline_Footer_Body_Logo');
        logo_elm.innerHTML = logo_html;//

    }
    var modifyWidgetUi = function(dim){
        if(WIDGET_MODE == 1){
            return;
        }
        CONTENT_H = dim.height;
        $('.kintoneSI-widget-body').animate({'height': CONTENT_H + 'px'});
        if (localStorage.getItem('kintoneSI-toggle') != 'true'){
            var modify_h = parseInt(CONTENT_H) + 2;
            $('.kintoneSI-widget').css({'bottom': '-' + modify_h + 'px'});
        }

        localStorage.setItem('kintoneSI-height', CONTENT_H);
    }
    var _getNowYmd = function(unix_time){
    	return Brekeke.Utility.comDateFormat(new Date(unix_time),'yyyy-MM-ddTHH:mm:00Z');
    }
    var _getBrekekeSource = function(){
        var sourcesInfo = Brekeke.Toolbar.getWidget().getSourcesInfo();
        if(sourcesInfo){
            for(var i=0; i < sourcesInfo.length ; i++){
                var sourceInfo = sourcesInfo[i];
                if(sourceInfo.isSourceOrigin && sourceInfo.sourceType == Brekeke.CTI.DCIWorkView.Constants.SOURCE_TYPE_WEBCHAT){
                    return sourceInfo.source;
                } else if(sourceInfo.isSourceOrigin && sourceInfo.sourceType == Brekeke.CTI.DCIWorkView.Constants.SOURCE_TYPE_CALL){
                    return sourceInfo.source;
                }
            }
        }
        return null;
    }
    var _getUrlParam = function(){
        //get val from param
        var arg = {};

        var s1 = location.href.split("?");
        if( s1.length <= 1 ){
            s1 = location.href.split("#");
        }
        if( s1.length > 1 ){
            var s2 = s1[1].split("&");
            for(var i = 0; i< s2.length; i++ ){
                var s3 = s2[i].split("=");
                if(s3.length >= 2){
                    arg[s3[0]] = s3[1];
                }
            }
        }

        return arg;
    }
    var _isBrekeke = function(){
        var arg = _getUrlParam();
        return arg['brekeke'];
    }


    var addCallStyle = function(elm){
        elm.style.cursor = "pointer";
        elm.style.textDecoration = "underline";
        elm.style.color = "#217dbb";
        elm.onclick = function(){
        	var agentInfo = Brekeke.Toolbar.getWidget().getAgentInfo();
        	if(agentInfo.agentState != Brekeke.CTI.DCIWorkView.Constants.AGENT_STATE_WORK){
        		alert('エージェント状態をワークにしてください');
        		return;
        	}
            var tel = this.innerText;
            tel = tel.replace(/\?/g, '');
            tel = tel.replace(/-/g, '');
            tel = tel.replace(/－/g, '');
            tel = tel.replace(/\n/g, '');
            tel = tel.replace(/×/g, '0');

            tel = tel.replace(/x/g, '0');
            tel = tel.replace(/X/g, '0');

            var ci = {customer:tel,fromno:'dialer'};
            var name = elm.getAttribute('company_name');
            if(name){
                ci.customerInfo=name;
            }
            Brekeke.Toolbar.getWidget().operate(Brekeke.CTI.DCIWorkView.Constants.makeCall,ci,'');

            var recordId = elm.getAttribute('record_id');
            if(recordId) {
                setTimeout(function () {
                    Brekeke.Toolbar.getWidget().requestAppPopup({url:KINTON_URL + '/k/' + APPKEY + '/show#record=' + recordId + '&l.sort_0=f5118288&l.order_0=DESC&l.view=5118336&l.q&mode=edit&brekeke=1' + '&date=' + Brekeke.Utility.getDate(),windowed:true,appSpan:0});
                },1000);
            }
        }
    }

    //一覧
    var listHander = function(event){

        showWidget();

        var widget = Brekeke.Toolbar.getWidget();
        if(widget && widget.state == Brekeke.CTI.DCIWorkView.Constants.OBJECT_STATE_ENABLE){
            setTimeout(function() {
                location.reload();//reloadしないと、RFSリンクがうまく表示できない現象がありました。
            },10);
            return event;
        }

        var ev ={};

        var _isBrekekWindow = _isBrekeke();
        ev[Brekeke.CTI.DCIWorkView.Constants.appValidationRequested] = function(continueFunc){
            if (_isBrekekWindow) {
                continueFunc(null,'コンタクトを放棄してよろしいですか？');
                return;
            }
            continueFunc(true);
        }
        ev[Brekeke.CTI.DCIWorkView.Constants.eventOccurred] = function(ev){
            if(ev.eventCode == 'widget-resize') {
                modifyWidgetUi(ev.eventObject);
            }
        };
        Brekeke.Toolbar.start({
            init_func:function(){
                    var tel_elms = kintone.app.getFieldElements(TEL_FIELD_CODE);
                    if (_isBrekekWindow) {
                        if (!tel_elms || tel_elms.length == 0) {
                            window.location.href = '/k/'+ APPKEY + '/edit?brekeke=1';
                        } else if (tel_elms.length == 1) {
                            var recordId = tel_elms[0].getAttribute('record_id');
                            window.location.href = '/k/'+ APPKEY + '/show#record=' + recordId + '&l.sort_0=f5118288&l.order_0=DESC&l.view=5118336&l.q&mode=edit&brekeke=1' + '&date=' + Brekeke.Utility.getDate();
                        } else {
                           var linkList = document.getElementsByTagName('a');
                           for ( var i = 0; i < linkList.length; i++ ) {
                               var elm = linkList[i];
                               var href = elm.getAttribute('href');
                               if(href && href.indexOf('/k/'+ APPKEY + '/show#') == 0){
                                   elm.setAttribute('href',href + '&mode=edit&brekeke=1');
                               }
                           }
                        }
                    } else {
                        if(tel_elms) {
                            for (var i = 0; i < tel_elms.length; i++) {
                                if (!tel_elms[i].innerText) {
                                    continue;
                                }
                                addCallStyle(tel_elms[i]);
                            }
                        }
                    }
                    Brekeke.debug('>>>(cybozu list)brekeke init');
                },
            ev_handler:ev
        })
        var tel_elms = kintone.app.getFieldElements(TEL_FIELD_CODE);
        if(tel_elms) {
            var records = event.records;
            for (var i = 0; i < records.length; i++) {
                var recordId = records[i]['$id'].value;
                var name = records[i][CUSTOMER_FIELD_CODE].value;
                tel_elms[i].setAttribute('record_id', recordId);
                tel_elms[i].setAttribute('company_name', name);
            }
        }

        Brekeke.debug('>>>(cybozu) list end');
        return event;

    }

    //詳細画面
    var detailHander = function(event){

        showWidget();

        var ev ={};

        var rfs_elm_hash = {};
        //詳細画面の録音
        ev[Brekeke.CTI.DCIWorkView.Constants.operationResult] = function(ev){
            if(ev.operationName == Brekeke.CTI.DCIWorkView.Constants.createRecordingFileUrl && ev.id == "cybozu"){

                var results = ev.value;
                if(results){
                    for(var i=0; i< results.length; i++){
                        var result = results[i];
                        var elm = rfs_elm_hash[result.rid + "_" + result.agentId];
                        if(elm){
                            //elm.innerHTML = "<a href='" + result.url + "' >録音</a>";
                            elm.innerHTML = "<audio src='" + result.url + "' controls='controls' preload='none' >"

                            Brekeke.debug('>>>(cybozu detail)brekeke rfs='  + result.url);
                        }
                    }
                }

                Brekeke.debug('>>>(cybozu detail)brekeke operationResult='  + JSON.stringify(ev));
            }

        }
        ev[Brekeke.CTI.DCIWorkView.Constants.eventOccurred] = function(ev){
            if(ev.eventCode == 'widget-resize') {
                modifyWidgetUi(ev.eventObject);
            }
        };
        var widget = Brekeke.Toolbar.getWidget();
        if(widget && widget.state == Brekeke.CTI.DCIWorkView.Constants.OBJECT_STATE_ENABLE){
            setTimeout(function() {
                location.reload();//reloadしないと、RFSリンクがうまく表示できない現象がありました。
            },10);
            return event;
        }

        Brekeke.Toolbar.start({
            init_func:
                function(){

                    setTimeout(function() {
                        //TELのCALLTO
                        var elm = kintone.app.record.getFieldElement(TEL_FIELD_CODE);
                        if (elm) {
                            elm = elm.children[0];

                            var record = kintone.app.record.get();
                            var recordId = record.record['$id'].value;

                            var name = record.record[CUSTOMER_FIELD_CODE].value;
                            elm.setAttribute('record_id', recordId);
                            elm.setAttribute('company_name', name);

                            addCallStyle(elm);

                        }

                        var elms = document.querySelectorAll(ACTIVITY_RFS_FIELD_CLASS);
                        if (elms) {
                            var list = [];
                            for (var i = 0; i < elms.length; i++) {
                                var all = elms[i].innerText;
                                if (all) {
                                    var each = all.split('_');
                                    if (each.length >= 2) {
                                        var rid = each[1];
                                        var agentId = each[2];
                                        rfs_elm_hash[rid + "_" + agentId] = elms[i];
                                        list.push({rid: each[1], agentId: agentId});
                                    }
                                }

                            }
                            if (list.length > 0) {
                                var agentInfo = Brekeke.Toolbar.getWidget().getAgentInfo();
                                if (agentInfo.agentState != Brekeke.CTI.DCIWorkView.Constants.AGENT_STATE_OFFLINE){
                                    Brekeke.Toolbar.getWidget().operate(Brekeke.CTI.DCIWorkView.Constants.createRecordingFileUrl, {
                                        keys: list,
                                        audio: true
                                    }, 'cybozu');
                                }
                            }

                        }
                        Brekeke.debug('>>>(cybozu detail)brekeke init');
                    },1000);



                },
            ev_handler:ev
        });

        Brekeke.debug('>>>(cybozu) detail end');


        return event;
    }

    var newHandler = function(event){
        showWidget();

        var ev ={};

        var _isBrekekWindow = _isBrekeke();
        ev[Brekeke.CTI.DCIWorkView.Constants.appValidationRequested] = function(continueFunc){
            if (_isBrekekWindow) {
                continueFunc(null,'コンタクトを放棄してよろしいですか？');
                return;
            }
            continueFunc(true);
        }
        ev[Brekeke.CTI.DCIWorkView.Constants.eventOccurred] = function(ev){
            if(ev.eventCode == 'widget-resize') {
                modifyWidgetUi(ev.eventObject);
            }
        };
        Brekeke.Toolbar.start({
            init_func: function () {
                setTimeout(function () {
                    //cancel button nodisplay
                    if (_isBrekekWindow) {
                        var cancelButton = document.getElementsByClassName('gaia-ui-actionmenu-cancel');
                        if (cancelButton && cancelButton.length > 0) {
                            cancelButton[0].style.display = 'none';
                        }
                    }
                },100);
                var agentInfo = Brekeke.Toolbar.getWidget().getAgentInfo();
                var source = _getBrekekeSource();
                if (source ) {
                    var record = kintone.app.record.get();
                    var line = record.record['活動履歴']['value'][0]['value'];

                    if (source.callId){
                        record.record[TEL_FIELD_CODE].value = source.customerNumber;

                        var type = source.firstAgentCallType;
                        type = (type == Brekeke.CTI.DCIWorkView.Constants.CALL_TYPE_INBOUND || type == Brekeke.CTI.DCIWorkView.Constants.CALL_TYPE_ACD ? 'インバウンド' : 'アウトバウンド');

                        line[ACTIVITY_CALL_TYPE_FIELD_CODE]['value'] = type;
                        //line[ACTIVITY_TYPE_FIELD_CODE]['value'] = '電話';
                        line[ACTIVITY_RFS_FIELD_CODE]['value'] = agentInfo.tenantName + "_" + source.callId + "_" + agentInfo.agentId;
                    } else {
                        // record.record.EMAIL.value = source.customerEmail;
                        // line[ACTIVITY_TYPE_FIELD_CODE]['value'] = 'チャット';
                    }
                    line[ACTIVITY_DATE_FIELD_CODE]['value'] = _getNowYmd(source.startTime);

                    kintone.app.record.set(record);
                    Brekeke.debug('>>>(cybozu new)brekeke init=' + JSON.stringify(record));
                }


            },
            ev_handler:ev
        });

        var record = event.record;

        Brekeke.debug('>>>(cybozu) new end');
        return event;

    }
    var chkDupActivity = function(id,lines){
        var dup = false;
        lines.forEach(function(line){
            var val_obj = line['value'];
            var exist_id = val_obj[ACTIVITY_RFS_FIELD_CODE]["value"];
            if(exist_id == id){
                dup = true;
            }})
        return dup;
    }

    var editHandler = function(event){
        showWidget();


        var ev ={};

        var _isBrekekWindow = _isBrekeke();
        ev[Brekeke.CTI.DCIWorkView.Constants.appValidationRequested] = function(continueFunc){
            if (_isBrekekWindow) {
                continueFunc(null,'コンタクトを放棄してよろしいですか？');
                return;
            }
            continueFunc(true);
        }
        ev[Brekeke.CTI.DCIWorkView.Constants.eventOccurred] = function(ev){
            if(ev.eventCode == 'widget-resize') {
                modifyWidgetUi(ev.eventObject);
            }
        };
        Brekeke.Toolbar.start({
            init_func: function () {

                var agentInfo = Brekeke.Toolbar.getWidget().getAgentInfo();
                var source = _getBrekekeSource();
                if (source ) {

                    setTimeout(function () {
                        //cancel button nodisplay
                        if (_isBrekekWindow) {
                            var cancelButton = document.getElementsByClassName('gaia-ui-actionmenu-cancel');
                            if (cancelButton && cancelButton.length > 0) {
                                cancelButton[0].style.display = 'none';
                            }
                        }

                        var record = kintone.app.record.get();


                        var callType = '';
                        var actionType = '電話';
                        var rfsInfo = '';

                        if (source.callId){
                            callType = source.firstAgentCallType;
                            callType = (callType == Brekeke.CTI.DCIWorkView.Constants.CALL_TYPE_INBOUND || callType == Brekeke.CTI.DCIWorkView.Constants.CALL_TYPE_ACD ? 'インバウンド' : 'アウトバウンド');
                            rfsInfo  = agentInfo.tenantName + "_" + source.callId + "_" + agentInfo.agentId;
                        } else {
                            actionType = 'チャット';
                        }
                        //重複チェック
                        var lines = record.record['活動履歴']['value'];
                        if(chkDupActivity(rfsInfo,lines)){
                            Brekeke.debug('>>>(cybozu edit)dup call=' + rfsInfo);
                            return;
                        }

                        //value obj
                        var val_obj = {};
                        val_obj[ACTIVITY_DATE_FIELD_CODE] = {"type": "DATE", "value": _getNowYmd(source.startTime)};
                        //val_obj[ACTIVITY_TYPE_FIELD_CODE] = {"type": "DROP_DOWN", "value": actionType};
                        val_obj[ACTIVITY_CALL_TYPE_FIELD_CODE] = {"type": "DROP_DOWN", "value": callType};
                        val_obj[ACTIVITY_RFS_FIELD_CODE] = {
                            "type": "SINGLE_LINE_TEXT",
                            "value": rfsInfo
                        };
                        if(ACTIVITY_OTHER_FIELDS_INFO) {
                            for (var key in ACTIVITY_OTHER_FIELDS_INFO) {
                                val_obj[key] = ACTIVITY_OTHER_FIELDS_INFO[key];
                            }
                        }

                        var line = {
                            "id": null,
                            "value": val_obj
                        };

                        lines.push(line);
                        kintone.app.record.set(record);
                        Brekeke.debug('>>>(cybozu edit)brekeke init=' + JSON.stringify(record));
                    }, 1000);
                }
            },
            ev_handler:ev
        });

        var record = event.record;

        Brekeke.debug('>>>(cybozu) edit end');
        return event;

    }


    //レコード一覧イベントを取得
    kintone.events.on('app.record.index.show', listHander);
    kintone.events.on('app.record.detail.show', detailHander);
    kintone.events.on('app.record.create.show', newHandler);
    kintone.events.on('app.record.edit.show', editHandler);

    


})();